#include "dialog.h"
#include "ui_dialog.h"

Dialog::Dialog(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Dialog)
{
    ui->setupUi(this);
	setWindowTitle(QCoreApplication::applicationName());
	ui->lineEdit_server_address->setText("192.168.0.100");
	ui->lineEdit_server_port->setText("2000");
	am_freq = "594";
	fm_freq = "82.5";
	ui->radioButton_am->click();
	radio.start();
}

Dialog::~Dialog()
{
	radio.stop();
	delete ui;
}

void Dialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void Dialog::on_receiveButton_clicked()
{
	std::string addr = ui->lineEdit_server_address->text().toStdString();
	std::string port = ui->lineEdit_server_port->text().toStdString();
	radio.bind(addr.c_str(), atoi(port.c_str()));

	if (ui->radioButton_am->isChecked()) {
		int f = atoi(am_freq.toStdString().c_str());
		radio.tune_am(f);
	} else if (ui->radioButton_fm->isChecked()) {
		int f = (int)(atof(fm_freq.toStdString().c_str()) * 100);
		radio.tune_fm(f);
	}

	radio.play(true);
	ui->pauseButton->setEnabled(true);
}

void Dialog::on_pauseButton_clicked()
{
	radio.play(false);
	ui->receiveButton->setFocus();
	ui->pauseButton->setEnabled(false);
}

void Dialog::on_radioButton_am_clicked()
{
	ui->lineEdit_freq->setText(am_freq);
	ui->label_freq->setText("kHz");
}

void Dialog::on_radioButton_fm_clicked()
{
	ui->lineEdit_freq->setText(fm_freq);
	ui->label_freq->setText("MHz");
}

void Dialog::on_lineEdit_freq_textChanged(QString str)
{
	if (ui->radioButton_am->isChecked()) {
		am_freq = str;
	} else if (ui->radioButton_fm->isChecked()) {
		fm_freq = str;
	}
}
